/*
 * IPhoneTemperSoftware.cpp
 *
 * Created: 17.04.2015 02:09:06
 *  Author: Tim
 */ 


#include <avr/io.h>
#include "lcd-routines.h"
#include <stdlib.h>
#define F_CPU 8000000
#include <util/delay.h>
#include "i2cmaster.h"

#define lm75_r 0x90      //Leseadresse des LM75
uint8_t msb_temp;        //Oberes Temperatur-Byte
uint8_t lsb_temp;        //Unteres Temperatur-Byte
uint16_t temp_wrd;       //Ganzes Temperatur-Wort
uint8_t ret;             //Kontrollvariable fr I2C Kommunik.
//uint8_t x;               //X-Position der Kommastelle
signed char temperatur;  //Variable m. Vorzeichen fr die Temp.berechnung
//char Buffer[20];         //Umwandlungs-Variable fr LCD Anzeige

void temperfassung(void) {
	ret = i2c_start(lm75_r);      //Start Lesen des LM75

	if (ret == 0) {               //Wenn LM75 ein OK sendet...
		msb_temp = i2c_readAck();   //...speichere oberes Bit
		lsb_temp = i2c_readNak();   //...speichere unteres Bit
	}
	else {                        //Wenn LM75 kein OK sendet
		lcd_setcursor(0,1);     // POsition 0 0
		lcd_string("Error beim Lesen");
	}
}

	/* ADC initialisieren */
	void ADC_Init(void)
	{
	  // die Versorgungsspannung AVcc als Refernz whlen:
	  ADMUX = (1<<REFS0);    
 
	  // Bit ADFR ("free running") in ADCSRA steht beim Einschalten
	  // schon auf 0, also single conversion
	  ADCSRA = (1<<ADPS1) | (1<<ADPS0);     // Frequenzvorteiler
	  ADCSRA |= (1<<ADEN);                  // ADC aktivieren
 
	  /* nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
		 also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */
 
	  ADCSRA |= (1<<ADSC);                  // eine ADC-Wandlung 
	  while (ADCSRA & (1<<ADSC) ) {         // auf Abschluss der Konvertierung warten
	  }
	  /* ADCW muss einmal gelesen werden, sonst wird Ergebnis der nchsten
		 Wandlung nicht bernommen. */
	  (void) ADCW;
	}
//----------------------------------------------------------------------------------------	
	// Text in einzelnen Zeichen ausgeben
	void lcd_Dezimal (int zahl)
	{
		// ... umwandeln siehe FAQ Artikel bei http://www.mikrocontroller.net/articles/FAQ
		// WinAVR hat eine itoa()-Funktion, das erfordert obiges #include <stdlib.h>
		char Buffer[20]; // in diesem {} lokal
		itoa( zahl, Buffer, 10 );
		
		// ... ausgeben
		lcd_string( Buffer );
	}
//----------------------------------------------------------------------------------------	
/* ADC Einzelmessung */
uint16_t ADC_Read( uint8_t channel )
	{
		// Kanal waehlen, ohne andere Bits zu beeinfluen
		ADMUX = (ADMUX & ~(0x1F)) | (channel & 0x1F);
		ADCSRA |= (1<<ADSC);            // eine Wandlung "single conversion"
		while (ADCSRA & (1<<ADSC) ) {   // auf Abschluss der Konvertierung warten
		}
		return ADCW;                    // ADC auslesen und zurckgeben
	}
//----------------------------------------------------------------------------------------

void an (void)
{
	PORTA |= (1<<PA1);
}

void aus (void)
{
	PORTA &= (0<<PA1);	
}
	
int main( void )
{
	
  uint16_t adcval = 0;
  ADC_Init();
  lcd_init();
  i2c_init();                // Starte I2C Bus
  DDRA = 0x02;
  
	  while( 1 )
	  {
		  
		 temperfassung();                        //Start der Temp.auslesung
		 
		 lcd_setcursor(0,1);
		 lcd_Dezimal(msb_temp);
		 
		 _delay_ms(3000);
		  
		  
		 //---------- 
		adcval = ADC_Read(0);  // Kanal 0

		if ( adcval <= 50 )
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 0/20 ");
			aus();
			_delay_ms(200);		
		}
		else if ((adcval > 50) && (adcval <= 100))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 1/20 ");
			an();
			_delay_ms(10);
			aus();
			_delay_ms(190);		
		}
		else if ((adcval > 100) && (adcval <= 150))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 2/20 ");
			an();
			_delay_ms(20);
			aus();
			_delay_ms(180);
		}	
		else if ((adcval > 150) && (adcval <= 200))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 3/20 ");
			an();
			_delay_ms(30);
			aus();
			_delay_ms(170);			
		}		
		else if ((adcval > 200) && (adcval <= 250))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 4/20 ");
			an();
			_delay_ms(40);
			aus();
			_delay_ms(160);			
		}		
		else if ((adcval > 250) && (adcval <= 300))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 5/20 ");
			an();
			_delay_ms(50);
			aus();
			_delay_ms(150);			
		}		
		else if ((adcval > 300) && (adcval <= 350))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 6/20 ");
			an();
			_delay_ms(60);
			aus();
			_delay_ms(140);			
		}		
		else if ((adcval > 350) && (adcval <= 400))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 7/20 ");
			an();
			_delay_ms(70);
			aus();
			_delay_ms(130);			
		}	
		else if ((adcval > 400) && (adcval <= 450))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 8/20 ");
			an();
			_delay_ms(80);
			aus();
			_delay_ms(120);			
		}		
		else if ((adcval > 450) && (adcval <= 500))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 9/20 ");
			an();
			_delay_ms(90);
			aus();
			_delay_ms(110);			
		}		
		else if ((adcval > 500) && (adcval <= 550))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 10/20 ");
			an();
			_delay_ms(100);
			aus();
			_delay_ms(100);			
		}
		else if ((adcval > 550) && (adcval <= 600))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 11/20 ");
		}		
		else if ((adcval > 600) && (adcval <= 650))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 12/20 ");
		}		
		else if ((adcval > 650) && (adcval <= 700))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 13/20 ");
		}		
		else if ((adcval > 700) && (adcval <= 750))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 14/20 ");
		}		
		else if ((adcval > 750) && (adcval <= 800))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 15/20 ");
		}		
		else if ((adcval > 800) && (adcval <= 850))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 16/20 ");
		}				
		else if ((adcval > 850) && (adcval <= 900))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 17/20 ");
		}				
		else if ((adcval > 900) && (adcval <= 950))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 18/20 ");
		}				
		else if ((adcval > 950) && (adcval <= 1000))
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 19/20 ");
		}				
		else if (adcval > 1000)
		{
			lcd_setcursor(0,2);
			lcd_string("Leistung: 20/20 ");
		}				
		
	  }
	  
  return 0;
}
